* Lost's rebuild of Trev's attempt at creating a coco asm game
* as of June 9, 2009.
* Thanks Lost, now for Trev to improve and learn more.

* Making it not so bad coding
	INCLUDE Coco3_Hdwr.asm	* Hardware of the coco3 constants
	INCLUDE AppData.asm	* Data Specific stuff

* this first routine relocates the code to the top 8K block of RAM
* or $E000
	org	TempStorage	somewhere safe to load at initially
	setdp 	*/256
start	orcc	#IntMask	disable interrupts
	ldu	#AppData	point to start of destination
	leay	<main,pcr	point to main code
	ldx	#(end-main)/2+1	words to copy	+1 in case of odd number of bytes
	clr	65497      	FAST POKE
a@	ldd 	,y++		= copy a word
	std 	,u++		=
	leax	-1,x		done yet?
	bne	a@		branch if not
	jmp	AppData		transfer control to newly copied program

* this is the actual main code

* NOTE: this is all position independent for simplicity; if it wasn't, the
* relocation routine above would not be sufficient; we would also need to do
* some really annoying contortions in here so that it would assemble
* correctly.  Instead, the position independent code means we can just plop
* this anywhere in memory.  However, position independent code is usually
* slightly slower than the equivalent position dependent code.
main	leas	main,pcr	* put stack somewhere useful, that will not get trashed by application
	* Set up Frame1
	ldd	#$3031		* put graphics screen in low memory
	std	GimeMap0Reg1	*
	incb			* increment b from $31 to $32 and set last required Gime Page
	stb	GimeMap0Reg3	*
	lda	#$4C		= enable graphics mode
	sta	Init0		=
	ldd	#$801A		=
	std	VMode		= set VMode and VRes
	clr	VertScroll	vertical scroll to 0
	ldd	#FrameOne	* video start address
	std	VertOffset	*
	clr	HorizOffset	clear horiz scroll

* set palette regs
	leay 	palette,pcr	point to palette values
	ldx 	#GimePalette	point to palette regs
	lda 	#PaletteSize	16 palette registers
a@	ldb 	,y+		* copy palette value
	stb 	,x+		*
	deca			done yet?
	bne 	a@		brif not

	lbsr	pclear

* Initialise screenswap parameters 
	lda	#$FF		= flag screen #1 as
	sta	CurScreen	= currently being shown	

* Start VBord Interrupt
	lda	#$08		* This relates to Bit 3 of FF92 enable vertical vsync	
	sta	IRQENR		* Vert Border IRQ enabled(Bit3)
	lda 	#$7E		* jmp instruction
	leax	irq,pcr		* irq handler
	sta	VIRQ		* set IRQ vector
	stx	VIRQ+1		*
	andcc	#IntEnableMask	* enable IRQ Interrupts

* paint the tiles on the screen
; 	ldy 	#Rows0Base-TileSize	Y coord to bottom right of screen
; 	ldb 	#Rows0Base/TileSize	how many on screen vertically
; a@	ldx 	#Columns-TileSize	X coord to bottom right
; 	lda 	#Columns/TileSize	how many on screen horizontally
; 	ldu	#Mario1-atile		Calculate Tile offset
; b@	lbsr 	drawTile		draw a tile
; 	leax 	-TileWidth,x		move to next coord
; 	deca				finished a line?
; 	bne 	b@			brif not done
; 	leay 	-TileWidth,y		move to next row up
; 	decb				finished the screen?
; 	bne 	a@			brif not done

; clear both screens
	lbsr	pclear
	lbsr	DFrame
	lbsr	pclear
	lbsr	DFrame	

* Point back to Frame 1
;	lbsr	Frame1
* Clear up all things
	ldx	#0
	ldy	#0
	stx	MarioFrame1
	stx	MarioFrame2

* Test animation
	ldx	MarioFrame1
a@	lbsr	MarioStartRight
	lda	#25
b@	lbsr	MarioRight	* Move Right 5 steps
	deca
	bne	b@		* Count down the steps
	lbsr	MarioStopRight
	lbsr	MarioStandRight	* Hold on there
	lbsr	MarioStandLeft
	lbsr	MarioStartLeft
	lda	#25
c@	lbsr	MarioLeft	* Move Left 5 steps
	deca
	bne	c@
	lbsr	MarioStopLeft
	lbsr	MarioStandLeft
	bsr	MarioStandRight	* Hold on there
	bra	a@		* Jump back to run again

* Show Mario Animation Tiles
	;lbsr	Frame2
;	lda	#0
;a@	lbsr	getTile
;	lbsr	drawTile
;	lbsr	DFrame
;	inca
;	leax	16,x	
;	cmpa	#12
;	bne	a@
	;lbsr	Frame1
;	bra	*

MarioStandRight
	pshs	d
	lbsr	getPos
	lbsr	clrTile
	lda	#$07
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc
		
MarioStartRight
	pshs	d
	;1st sprite
	;$0700,$0800,$0A00,$0A01
	lbsr	getPos
	lbsr	clrTile
	lda	#$07
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;2nd
	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	lbsr	setPos
	lda	#$08
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;3rd
	lbsr	getPos
	lbsr	clrTile
	lda	#$0A
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;4th
	lbsr	getPos
	lbsr	clrTile
	leax	SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc

MarioRight
	pshs	d
	; $0901,$0901,$0901,$0801,$0801,$0801,$0A01,$0A01,$0A01
	;1st
	ldb	#3
	lda	#$09
	lbsr	getTile
b@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	SpriteSpeed,x
	lbsr	drawTile
	lbsr	setPos
	lbsr	DFrame		; vsync
	decb
	bne	b@
	
	; next move
	ldb	#3
	lda	#$08
	lbsr	getTile
b@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	SpriteSpeed,x
	lbsr	drawTile
	lbsr	setPos	
	lbsr	DFrame		; vsync
	decb
	bne	b@
	
	; Next Move
	ldb	#3
	lda	#$0A
	lbsr	getTile
b@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	SpriteSpeed,x
	lbsr	drawTile
	lbsr	setPos	
	lbsr	DFrame		; vsync
	decb
	bne	b@
	puls	d,pc

MarioStopRight
	pshs	d
	lbsr	getPos
	; $0A01,$0A00,$0800,$0700
	lbsr	clrTile
	lda	#$0A
	lbsr	getTile
	lbsr	getPos2
	leax	SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	;2nd
	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	;3rd
	lbsr	getPos
	lbsr	clrTile
	lda	#$08
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;4th
	lbsr	getPos
	lbsr	clrTile
	lda	#$07
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc

		
MarioStandLeft
	pshs 	d
	lbsr	getPos
	lbsr	clrTile
	lda	#$06
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc

MarioStartLeft
	pshs	d
	; $0600,$0500,$0300,$0301
	lbsr	getPos
	lbsr	clrTile
	lda	#$06
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;2nd
	lbsr	getPos
	lbsr	clrTile
	lda	#$05
	lbsr	getTile
	lbsr	getPos2
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	;3rd
	lbsr	getPos
	lbsr	clrTile
	lda	#$03
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;4th
	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	-SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc
	
MarioLeft
	pshs	d
	; $0401,$0401,$0401,$0501,$0501,$0501,$0301,$0301,$0301
	lda	#$04
	ldb	#3
	lbsr	getTile
a@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	-SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame		; vsync
	decb
	bne	a@
	
	;next move
	lda	#$05
	ldb	#3
	lbsr	getTile
a@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	-SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame		; vsync
	decb
	bne	a@
	
	; Next Move
	lda	#$03
	ldb	#3
	lbsr	getTile
a@	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	leax	-SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame		; vsync
	decb
	bne	a@
	puls	d,pc

MarioStopLeft
	pshs	d
	lbsr	getPos
	; $0301,$0300,$0500,$0600
	lbsr	clrTile
	lda	#$03
	lbsr	getTile
	lbsr	getPos2
	leax	-SpriteSpeed,x
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	;2nd
	lbsr	getPos
	lbsr	clrTile
	lbsr	getPos2
	;lbsr	getTile
	lbsr	setPos
	lbsr	drawTile
	lbsr	DFrame
	;3rd
	lbsr	getPos
	lbsr	clrTile
	lda	#$05
	lbsr	getTile
	lbsr	drawTile
	lbsr	DFrame
	;4th
	lbsr	getPos
	lbsr	clrTile
	lda	#$06
	lbsr	drawTile
	lbsr	DFrame
	puls	d,pc

		
;* infinite loop
;	bra	*

; Returns current position of Mario in render frame in X
getPos	pshs	d
	lda	CurScreen
	beq	scrn2@
	ldx	MarioFrame1
	bra	done@
scrn2@	ldx	MarioFrame2
done@	puls	d,pc

; Returns current position of Mario in displayed frame in X
getPos2	pshs	d
	lda	CurScreen
	beq	scrn2@
	ldx	MarioFrame2
	bra	done@
scrn2@	ldx	MarioFrame1
done@	puls	d,pc


; Stores current position of Mario in current frame to right variable from X
setPos	pshs	d
	lda	CurScreen
	beq	scrn2@
	stx	MarioFrame1
	bra	done@
scrn2@	stx	MarioFrame2
done@	puls	d,pc
	


; wait top of frame, A times
; hhos:-> I looked up the addresses for VSYNC and VBORD. VSYNC is bit 7 of $FF03. VBORD is bit 3 of $FF92 for the IRQ, and bit 3 of $FF93 for the FIRQ.
; hhos:-> I do not understand. There are about 14900 cycles in a vsync period. That should be enough to do the erase and redraw.

;delay	pshs	d
;a@	;sync
;	lda	$FF03
;	bpl	a@
;	lda	$FF02
;	decb
;	bne	a@
	;bsr	DFrame
;	puls	d,pc
	
DFrame	pshs	d
	lda	#$FF
	sta	FrameReady
a@	lda	FrameReady	* Relies on interrupt clearing FrameReady
	bne	a@
	puls	d,pc
		
* so the tile number in D is really the offset from TILES for the start of the tile.
* Lost what you might also do is "ldd #tileaddr-TILES; leax TILES,PCR; leax d,x" and avoid all that messy math.

;lda tileentry; ldb #tilesize; mul; leax TILES,pcr; leax d,x;
* Calculated the address of a tile based on lsB of map (map params are 16 bit at this stage)
* pass a with the lsB of map reference
* return u with tile address
getTile
	pshs	d				'Ensure b is preserved
	ldb	#TileMemSize				
	mul					calculates tileNumber * tilesize to get tile offset address
	leau	Mario0,pcr
	leau	d,u
	puls	d,pc				restore a,b and return

* get address of pixel
* probably should code this for code size optimisation

* this clears the graphics screen
pclear	pshs	u,x,d
	ldu 	#0		start of graphics screen
	ldx 	#BytesPerScreen	bytes in screen
	ldd 	#0		value to clear to
a@	std 	,u++		clear two bytes
	leax 	-2,x		done yet?
	bne 	a@		brif not
	puls	u,x,d,pc

* clear tile routine
clrTile equ *						* Currently only clears half sprite.
	pshs 	x,y,u,d				preserve regs
	ldd 	2,s				get column number (x off the stack, faster than tfr x,d)
	lsra					* divide by two
	rorb					*
	pshs	d				save for later
	ldb	7,s				get row number LSB (faster than tfr y,d)
	lda	#BytesPerRow			160 bytes per row
	mul					now D has row offset
	addd	,s++				add in column offset
	tfr	d,y				now Y points to screen memory location
	ldu	#$0000				get tile info
	lda	#TileSize			# rows
a@	ldb	#TileWordWidth			# bytes divide 2
b@	stu	,y++				save to screen0
	decb					done yet?
	bne	b@				brif no
	leay	BytesPerRow-TileByteWidth,y	move to start of tile on next line
	deca					done last row?
	bne	a@				brif not
	puls	x,y,u,d,pc			restore regs and return

* draw tile routine
drawTile
	pshs 	x,y,u,d				preserve regs
	ldd 	2,s				get column number (x off the stack, faster than tfr x,d)
	lsra					* divide by two
	rorb					*
	pshs 	d				save for later
	ldb 	7,s				get row number LSB (faster than tfr y,d)
	lda 	#BytesPerRow			160 bytes per row
	mul					now D has row offset
	addd 	,s++				add in column offset
	tfr 	d,y				now Y points to screen memory location
	lda 	#TileSize			# rows
a@	ldb 	#TileWordWidth			# bytes divide 2
b@	ldx 	,u++				get tile info
	stx 	,y++				save to screen
	decb					done yet?
	bne 	b@				brif no
	leay 	BytesPerRow-TileByteWidth,y	move to start of tile on next line
	deca					done last row?
	bne 	a@				brif not
	puls 	x,y,u,d,pc			restore regs and return
	
; Frame1
; 	pshs	d
; 	orcc	#IntMask	disable interrupts
; 	ldd	#$3031		* put graphics screen in low memory
; 	std	GimeMap0Reg1	*
; 	;ldd	#$3233		*
; 	;std	GimeMap0Reg3	*
; 	incb			* increment b from $33 to $34 and set last required Gime Page
; 	;stb	GimeMap0Reg5	*
; 	stb	GimeMap0Reg3	*
; 	andcc	#IntEnableMask
; 	ldd	#FrameTwo	* video start address
; 	std	VertOffset	*
; 	puls	d,pc

; Frame2
; 	pshs	d
; 	orcc	#IntMask
; 	ldd	#$3334		* put graphics screen in low memory
; 	std	GimeMap0Reg1	*
; 	;ldd	#$3637		*
; 	;std	GimeMap0Reg3	*
; 	incb			* increment b from $33 to $34 and set last required Gime Page
; 	;stb	GimeMap0Reg5	*
; 	stb	GimeMap0Reg3	*
; 	andcc	#IntEnableMask
; 	ldd	#FrameOne	* video start address
; 	std	VertOffset	*
; 	puls	d,pc
	
* swap frame
irq	ldb	PIA0BD		; Reset Interrupt
	lda	FrameReady	check if ready for render
	bne	DoFlip
	rti
DoFlip	lda	CurScreen	get current screen flag
	beq	irqF1		branch if screen 1 right now
	* Set up Frame2 edit frame 2 show frame 1
	orcc	#IntMask
	ldd	#$3334		* put graphics screen in low memory
	std	GimeMap0Reg1	*
	incb			* increment b from $33 to $34 and set last required Gime Page
	stb	GimeMap0Reg3	*
	andcc	#IntEnableMask
	ldx	#FrameOne	get screen #1 addr
	bra	irqF2		continue
irqF1 equ *	* Set up Frame edit frame 1 show frame 2
	orcc	#IntMask
	ldd	#$3031		* put graphics screen in low memory
	std	GimeMap0Reg1	*
	incb			* increment b from $31 to $32 and set last required Gime Page
	stb	GimeMap0Reg3	*
	andcc	#IntEnableMask
	ldx	#FrameTwo	get screen #2 addr
irqF2	lda	CurScreen	; just incase it was mucked up
	coma			switch screen flag
	sta	CurScreen	save it
	stx 	VertOffset	set screen address
	clr	FrameReady	reset ready flag
	rti
	
* Sprite movments format sprite|offset going into a and b a=sprite, b=offset(D)
* $FFFF = end of movement
* Right Move Accelerate
RMoveA	FDB	$0700,$0800,$0A00,$0A01,$FFFF

* Right Move Constant
RMoveC  FDB	$0901,$0901,$0901,$0801,$0801,$0801,$0A01,$0A01,$0A01,$FFFF

* Right Move Decelerate
RMoveD	FDB	$0A01,$0A00,$0800,$0700,$FFFF

* Left Move Accelerate
LMoveA	FDB	$0600,$0500,$0300,$0301,$FFFF

* Left Move Constant
LMoveC	FDB	$0401,$0401,$0401,$0501,$0501,$0501,$0301,$0301,$0301,$FFFF

* Left Move Decelerate
LMoveD	FDB	$0301,$0300,$0500,$0600,$FFFF


* Mario Sprites here
Mario0
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
	
Mario1
	FDB	$5555,$0000,$0000,$0000
	FDB	$5555,$0777,$7770,$0000
	FDB	$5577,$7777,$7777,$0000
	FDB	$6666,$5655,$6666,$0000
	FDB	$6665,$5655,$5656,$6000
	FDB	$6555,$6555,$6656,$6000
	FDB	$0666,$6655,$5566,$6000
	FDB	$0065,$5555,$5550,$0000
	FDB	$0006,$7666,$7666,$6660
	FDB	$6607,$6667,$6666,$6666
	FDB	$6607,$7777,$6666,$6655
	FDB	$6675,$7757,$7677,$7555
	FDB	$6677,$7777,$7777,$6655
	FDB	$6677,$7777,$7776,$6660
	FDB	$0000,$0777,$7777,$6666
	FDB	$0000,$0000,$7777,$7066

Mario2
	FDB	$0000,$0777,$7770,$0000
	FDB	$0007,$7777,$7776,$6000
	FDB	$0000,$5656,$6666,$6600
	FDB	$0055,$5555,$6556,$5550
	FDB	$0556,$6556,$6556,$5550
	FDB	$0066,$5555,$5565,$5500
	FDB	$0005,$5766,$6777,$7000
	FDB	$0066,$6776,$5557,$7700
	FDB	$0066,$6666,$5556,$7700
	FDB	$0066,$6666,$5577,$7700
	FDB	$0006,$6667,$7777,$7000
	FDB	$0000,$7777,$6667,$7000
	FDB	$0000,$7776,$6666,$0000
	FDB	$0000,$0766,$6776,$6660
	FDB	$0000,$0000,$7666,$6660
	FDB	$0000,$0000,$0666,$6600
Mario3
	FDB	$0000,$0777,$7770,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0000,$5655,$6666,$0000
	FDB	$0055,$5655,$5656,$6000
	FDB	$0555,$6555,$6656,$6000
	FDB	$0066,$6655,$5566,$6000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0000,$0667,$7666,$6600
	FDB	$5556,$6677,$7666,$6555
	FDB	$5566,$7775,$7666,$5555
	FDB	$0660,$7777,$7777,$0555
	FDB	$0667,$7777,$7777,$7000
	FDB	$0667,$7777,$7777,$7700
	FDB	$0667,$7770,$0777,$6660
	FDB	$0000,$0000,$0006,$6660
	FDB	$0000,$0000,$0066,$6600
Mario4
	FDB	$0000,$0777,$7770,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0000,$5655,$6666,$0000
	FDB	$0055,$5655,$5656,$6000
	FDB	$0555,$6555,$6656,$6000
	FDB	$0066,$6655,$5566,$6000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0000,$0666,$7666,$0000
	FDB	$0000,$6677,$6666,$6000
	FDB	$0005,$7757,$7666,$6000
	FDB	$0007,$7777,$6666,$6000
	FDB	$0007,$7755,$5667,$7000
	FDB	$0000,$7775,$5677,$0000
	FDB	$0000,$6667,$7770,$0000
	FDB	$0006,$6666,$6660,$0000
	FDB	$0000,$0066,$6660,$0000
Mario5
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0777,$7770,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0000,$5655,$6666,$0000
	FDB	$0055,$5655,$5656,$6000
	FDB	$0555,$6555,$6656,$6000
	FDB	$0066,$6655,$5566,$6000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0005,$5676,$6666,$0000
	FDB	$0055,$5666,$6665,$5000
	FDB	$0005,$5666,$6675,$5500
	FDB	$0000,$7777,$7776,$6600
	FDB	$0000,$7777,$7777,$6600
	FDB	$0000,$0777,$7777,$6660
	FDB	$0000,$0066,$6600,$0660
	FDB	$0000,$0666,$6600,$0000
Mario6
	FDB	$0000,$0777,$7770,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0000,$5655,$6666,$0000
	FDB	$0055,$5655,$5656,$6000
	FDB	$0555,$6555,$6656,$6000
	FDB	$0066,$6655,$5566,$6000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0000,$0666,$7666,$0000
	FDB	$0066,$6766,$7666,$6000
	FDB	$0666,$6777,$7666,$6600
	FDB	$0556,$7577,$5765,$5500
	FDB	$0555,$7777,$7755,$5500
	FDB	$0557,$7777,$7775,$5500
	FDB	$0007,$7770,$7777,$0000
	FDB	$0066,$6600,$0666,$6000
	FDB	$0666,$6600,$0666,$6600
Mario7
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6676,$6660,$0000
	FDB	$0006,$6676,$6766,$6600
	FDB	$0066,$6677,$7766,$6660
	FDB	$0055,$6757,$7576,$5550
	FDB	$0055,$5777,$7775,$5550
	FDB	$0055,$7777,$7777,$5550
	FDB	$0000,$7777,$0777,$7000
	FDB	$0006,$6660,$0066,$6600
	FDB	$0066,$6660,$0066,$6660
Mario8
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6666,$7665,$5000
	FDB	$0005,$6666,$6655,$5500
	FDB	$0055,$7666,$6655,$5000
	FDB	$0066,$7777,$7777,$0000
	FDB	$0067,$7777,$7777,$0000
	FDB	$0667,$7777,$7770,$0000
	FDB	$0660,$0066,$6600,$0000
	FDB	$0000,$0066,$6660,$0000

Mario9
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6676,$6660,$0000
	FDB	$0006,$6667,$7666,$0000
	FDB	$0006,$6677,$5775,$5000
	FDB	$0006,$6667,$7777,$7000
	FDB	$0007,$6655,$5777,$7000
	FDB	$0000,$7655,$7777,$0000
	FDB	$0000,$0777,$6666,$0000
	FDB	$0000,$0666,$6666,$6000
	FDB	$0000,$0666,$6600,$0000
Mario10
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0066,$6677,$6660,$0000
	FDB	$5566,$6677,$7666,$5555
	FDB	$5555,$6675,$7776,$6555
	FDB	$5550,$7777,$7777,$0660
	FDB	$0007,$7777,$7777,$6660
	FDB	$0077,$7777,$7777,$6660
	FDB	$0667,$7770,$0777,$6660
	FDB	$0666,$6000,$0000,$0000
	FDB	$0066,$6600,$0000,$0000
Mario11
	FDB	$0000,$0777,$7770,$0000
	FDB	$0006,$7777,$7777,$7000
	FDB	$0066,$6666,$5655,$0000
	FDB	$0556,$5565,$5555,$5500
	FDB	$0556,$5566,$5566,$5550
	FDB	$0055,$6555,$5556,$6600
	FDB	$0007,$7766,$6755,$5000
	FDB	$0077,$5556,$7766,$6600
	FDB	$0076,$5556,$6666,$6600
	FDB	$0077,$7556,$6666,$6600
	FDB	$0007,$7777,$6666,$6000
	FDB	$0007,$6667,$7777,$0000
	FDB	$0000,$6666,$7777,$0000
	FDB	$0666,$7766,$6770,$0000
	FDB	$0666,$6677,$0000,$0000
	FDB	$0066,$6660,$0000,$0000
Mario12
	FDB	$0000,$0000,$0000,$5555
	FDB	$0000,$0777,$7770,$5555
	FDB	$0000,$7777,$7777,$7555
	FDB	$0000,$6665,$5655,$6666
	FDB	$0006,$5655,$5655,$6666
	FDB	$0006,$5665,$5565,$5566
	FDB	$0006,$6555,$5666,$6660
	FDB	$0000,$0555,$5555,$6600
	FDB	$0666,$6676,$6676,$6000
	FDB	$6666,$6667,$6667,$7066
	FDB	$5666,$6667,$7777,$7066
	FDB	$5557,$7677,$5775,$7666
	FDB	$5567,$7777,$7777,$7666
	FDB	$0666,$7777,$7777,$7666
	FDB	$6667,$7777,$7770,$0000
	FDB	$6607,$7777,$0000,$0000
Mario13
	FDB	$0000,$0077,$7777,$0000
	FDB	$0007,$7777,$7777,$7000
	FDB	$0000,$0565,$5666,$6000
	FDB	$0005,$5565,$5565,$6600
	FDB	$0055,$5655,$5665,$6600
	FDB	$0006,$6665,$5556,$6600
	FDB	$0000,$5555,$5555,$0000
	FDB	$0000,$0066,$6766,$6000
	FDB	$0000,$0666,$6777,$7000
	FDB	$0556,$6666,$6777,$7000
	FDB	$5556,$6666,$7777,$7000
	FDB	$5556,$6667,$7777,$7700
	FDB	$6677,$7777,$7777,$7700
	FDB	$0677,$7777,$7777,$7700
	FDB	$0000,$7777,$7777,$7000
	FDB	$0000,$0077,$7777,$0000
Mario14
	FDB	$0000,$0077,$7777,$0000
	FDB	$0007,$7777,$7777,$7000
	FDB	$0000,$0565,$5666,$6000
	FDB	$0005,$5565,$5565,$6600
	FDB	$0055,$5655,$5665,$6600
	FDB	$0006,$6665,$5556,$6600
	FDB	$0000,$5555,$5555,$0000
	FDB	$0055,$6666,$6777,$0000
	FDB	$0555,$6666,$6677,$7000
	FDB	$0555,$6666,$6677,$7700
	FDB	$0000,$0075,$7777,$7700
	FDB	$0660,$0077,$7777,$7700
	FDB	$0667,$7777,$7777,$7700
	FDB	$0667,$7777,$7777,$7000
	FDB	$0667,$7777,$7777,$0000
	FDB	$0000,$0000,$0000,$0000
Mario15
	FDB	$0000,$7777,$7700,$0000
	FDB	$0777,$7777,$7770,$0000
	FDB	$0005,$6556,$6660,$0000
	FDB	$0555,$6555,$6566,$0000
	FDB	$5556,$5556,$6566,$0000
	FDB	$0666,$6555,$5666,$0000
	FDB	$0055,$5555,$5500,$0000
	FDB	$5556,$6666,$7660,$0000
	FDB	$0556,$6666,$6770,$0000
	FDB	$0007,$6666,$7777,$0000
	FDB	$0000,$7777,$7776,$6600
	FDB	$0000,$0777,$7776,$6600
	FDB	$0000,$0007,$7776,$6600
	FDB	$0000,$0000,$6660,$6600
	FDB	$0000,$0000,$0660,$0000
	FDB	$0000,$0000,$0000,$0000
Mario16
	FDB	$0000,$7777,$7700,$0000
	FDB	$0777,$7777,$7770,$0000
	FDB	$0005,$6556,$6660,$0000
	FDB	$0555,$6555,$6566,$0000
	FDB	$5556,$5556,$6566,$0000
	FDB	$0666,$6555,$5666,$0000
	FDB	$0055,$5555,$5500,$0000
	FDB	$0000,$7666,$7660,$0000
	FDB	$0000,$6666,$6770,$0000
	FDB	$0005,$6666,$7777,$0000
	FDB	$0055,$6677,$7776,$6600
	FDB	$0055,$5777,$7776,$6600
	FDB	$0055,$0077,$7776,$6600
	FDB	$0000,$0000,$6660,$6600
	FDB	$0000,$0000,$0660,$0000
	FDB	$0000,$0000,$0000,$0000
Mario17
	FDB	$0000,$7777,$7700,$0000
	FDB	$0777,$7777,$7770,$0000
	FDB	$0005,$6556,$6660,$0000
	FDB	$0555,$6555,$6566,$0000
	FDB	$5556,$5556,$6566,$0000
	FDB	$0666,$6555,$5666,$0000
	FDB	$0055,$5555,$5500,$0000
	FDB	$0000,$7666,$7660,$0000
	FDB	$0000,$6666,$6770,$0000
	FDB	$0005,$6666,$7777,$0000
	FDB	$0055,$6677,$7776,$6000
	FDB	$0055,$5777,$7776,$6600
	FDB	$0055,$0077,$7666,$0000
	FDB	$0000,$0000,$0666,$6000
	FDB	$0000,$0000,$0066,$6000
	FDB	$0000,$0000,$0000,$0000
Mario18
	FDB	$0000,$7777,$7700,$0000
	FDB	$0777,$7777,$7770,$0000
	FDB	$0005,$6556,$6660,$0000
	FDB	$0555,$6555,$6566,$0000
	FDB	$5556,$5556,$6566,$0000
	FDB	$0666,$6555,$5666,$0000
	FDB	$0055,$5555,$5500,$0000
	FDB	$0000,$6676,$6660,$0000
	FDB	$0000,$6676,$6666,$0000
	FDB	$0000,$6677,$6666,$5500
	FDB	$0000,$0757,$7665,$5550
	FDB	$0000,$0777,$7776,$6600
	FDB	$0000,$0077,$7666,$0000
	FDB	$0000,$0000,$0666,$6000
	FDB	$0000,$0000,$0066,$6000
	FDB	$0000,$0000,$0000,$0000
Mario19
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6667,$6660,$0000
	FDB	$0006,$6667,$6660,$0000
	FDB	$0566,$6677,$6660,$0000
	FDB	$5556,$6775,$7700,$0000
	FDB	$0667,$7777,$7700,$0000
	FDB	$0006,$6777,$7000,$0000
	FDB	$0066,$6600,$0000,$0000
	FDB	$0066,$6000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
Mario20
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6766,$6770,$0000
	FDB	$0000,$7666,$6660,$0000
	FDB	$0007,$7766,$6655,$0000
	FDB	$0067,$7777,$6655,$5000
	FDB	$0667,$7777,$7755,$5000
	FDB	$0006,$6777,$7005,$5000
	FDB	$0066,$6600,$0000,$0000
	FDB	$0066,$6000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
Mario21
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6766,$6770,$0000
	FDB	$0000,$7666,$6660,$0000
	FDB	$0007,$7766,$6655,$0000
	FDB	$0667,$7777,$6655,$5000
	FDB	$0667,$7777,$7755,$5000
	FDB	$0667,$7777,$7005,$5000
	FDB	$0660,$6660,$0000,$0000
	FDB	$0000,$6600,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
Mario22
	FDB	$0000,$0777,$7770,$0000
	FDB	$0000,$7777,$7777,$7700
	FDB	$0000,$6665,$5655,$0000
	FDB	$0006,$5655,$5655,$5500
	FDB	$0006,$5665,$5565,$5550
	FDB	$0006,$6555,$5666,$6600
	FDB	$0000,$0555,$5555,$5000
	FDB	$0000,$6766,$6665,$5550
	FDB	$0000,$7666,$6665,$5500
	FDB	$0007,$7766,$6677,$0000
	FDB	$0667,$7777,$7770,$0000
	FDB	$0667,$7777,$7700,$0000
	FDB	$0667,$7777,$0000,$0000
	FDB	$0660,$6660,$0000,$0000
	FDB	$0000,$6600,$0000,$0000
	FDB	$0000,$0000,$0000,$0000
Mario23
	FDB	$0007,$7777,$7000,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0066,$6556,$5500,$0000
	FDB	$0656,$5556,$5555,$0000
	FDB	$0656,$6555,$6555,$5000
	FDB	$0665,$5556,$6666,$0000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0007,$7666,$6655,$5000
	FDB	$0077,$6666,$6655,$5500
	FDB	$0777,$6666,$6655,$5500
	FDB	$0777,$7757,$7000,$0000
	FDB	$0777,$7777,$7000,$6600
	FDB	$0777,$7777,$7776,$6600
	FDB	$0077,$7777,$7776,$6600
	FDB	$0007,$7777,$7776,$6600
	FDB	$0000,$0000,$0000,$0000
Mario24
	FDB	$0007,$7777,$7000,$0000
	FDB	$0077,$7777,$7777,$0000
	FDB	$0066,$6556,$5500,$0000
	FDB	$0656,$5556,$5555,$0000
	FDB	$0656,$6555,$6555,$5000
	FDB	$0665,$5556,$6666,$0000
	FDB	$0005,$5555,$5550,$0000
	FDB	$0066,$7666,$6000,$0000
	FDB	$0077,$7666,$6600,$0000
	FDB	$0077,$7666,$6665,$5500
	FDB	$0077,$7766,$6665,$5550
	FDB	$0777,$7776,$6665,$5550
	FDB	$0777,$7777,$7777,$6660
	FDB	$0777,$7777,$7777,$6600
	FDB	$0077,$7777,$7770,$0000
	FDB	$0007,$7777,$7000,$0000
Mario_Dead
	FDB	$0000,$0777,$7700,$0000
	FDB	$0055,$7777,$7775,$5000
	FDB	$5556,$5655,$6565,$5550
	FDB	$5566,$5655,$6566,$5550
	FDB	$5566,$6555,$5666,$5550
	FDB	$0066,$6655,$6666,$6000
	FDB	$0066,$5666,$6566,$0000
	FDB	$0006,$5555,$5566,$0000
	FDB	$0077,$7555,$5777,$7000
	FDB	$0667,$7666,$6776,$6600
	FDB	$0666,$7766,$7766,$6600
	FDB	$0666,$7577,$5766,$6600
	FDB	$0666,$7777,$7766,$6600
	FDB	$0066,$7777,$7766,$6000
	FDB	$0000,$0000,$0000,$0000
	FDB	$0000,$0000,$0000,$0000

atile	FDB	$0000,$0000,$0000,$0000
	FDB	$1111,$1110,$0011,$1111
	FDB	$2222,$2211,$0112,$2222
	FDB	$2222,$0221,$0122,$2222
	FDB	$2220,$2221,$0122,$0222
	FDB	$2222,$2221,$0120,$2222
	FDB	$2222,$2211,$0112,$2222
	FDB	$1111,$1110,$0011,$1111
	FDB	$0000,$0000,$0000,$0000
	FDB	$0011,$1111,$1111,$1110
	FDB	$0112,$2220,$2222,$2211
	FDB	$0122,$2202,$2222,$2221
	FDB	$0122,$2022,$2220,$2221
	FDB	$0122,$2222,$2202,$2221
	FDB	$0112,$2222,$2022,$2211
	FDB	$0011,$1111,$1111,$1110
		
* palette values
*	b5 b4 b3 b2 b1 b0
* RGB	R1 G1 B1 R0 G0 B0 	
* CMP   I1 I0 C3 C2 C1 C0
palette	FCB	%00000000,%00000111,%00111000,%00111111
	FCB	%00000100,%00110101,%00000110,%00100100
	FCB	%00010000,%00010010,%00000001,%00001000
	FCB	%00001001,%00110110,%00101101,%00011011


* this symbol MUST be at the end of the code and data that gets copied
end
	end start
